JUCE: RangedAudioParameterAttributes< Derived, Value > Class Template Reference

JUCE

Public Types | Public Member Functions | List of all members
RangedAudioParameterAttributes< Derived, Value > Class Template Reference
juce_audio_processors » utilities

`#include <juce_RangedAudioParameter.h>`

## Public Types
using | Category = AudioProcessorParameter::Category
using | StringFromValue = std::function< String(Value, int)>
using | ValueFromString = std::function< Value(const String &)>

## Public Member Functions
JUCE_NODISCARD auto | withStringFromValueFunction (StringFromValue x) const
| An optional lambda function that converts a non-normalised value to a string with a maximum length. More...
JUCE_NODISCARD auto | withValueFromStringFunction (ValueFromString x) const
| An optional lambda function that parses a string and converts it into a non-normalised value. More...
JUCE_NODISCARD auto | withLabel (String x) const
| See AudioProcessorParameterWithIDAttributes::withLabel() More...
JUCE_NODISCARD auto | withCategory (Category x) const
| See AudioProcessorParameterWithIDAttributes::withCategory() More...
JUCE_NODISCARD auto | withMeta (bool x) const
| See AudioProcessorParameter::isMetaParameter() More...
JUCE_NODISCARD auto | withAutomatable (bool x) const
| See AudioProcessorParameter::isAutomatable() More...
JUCE_NODISCARD auto | withInverted (bool x) const
| See AudioProcessorParameter::isOrientationInverted() More...
JUCE_NODISCARD const auto & | getStringFromValueFunction () const
| An optional lambda function that converts a non-normalised value to a string with a maximum length. More...
JUCE_NODISCARD const auto & | getValueFromStringFunction () const
| An optional lambda function that parses a string and converts it into a non-normalised value. More...
JUCE_NODISCARD const auto & | getAudioProcessorParameterWithIDAttributes () const
| Gets attributes that would also apply to an AudioProcessorParameterWithID. More...

## Detailed Description

template<typename Derived, typename Value>
class RangedAudioParameterAttributes< Derived, Value >

Holds common attributes of audio parameters.

CRTP is used here because we want the Attributes types for each parameter (Float, Bool, Choice, Int) to be distinct and extensible in the future. i.e. the identifiers AudioParameterFloatAttributes and RangedAudioParameterAttributes<float> should not be interchangable because we might need to add float-specific attributes in the future. Users should not refer directly to RangedAudioParameterAttributes.

## Member Typedef Documentation

## ◆ Category

template<typename Derived , typename Value >

using RangedAudioParameterAttributes< Derived, Value >::Category = AudioProcessorParameter::Category

## ◆ StringFromValue

template<typename Derived , typename Value >

using RangedAudioParameterAttributes< Derived, Value >::StringFromValue = std::function<String (Value, int)>

## ◆ ValueFromString

template<typename Derived , typename Value >

using RangedAudioParameterAttributes< Derived, Value >::ValueFromString = std::function<Value (const String&)>

## Member Function Documentation

## ◆ withStringFromValueFunction()

template<typename Derived , typename Value >

JUCE_NODISCARD auto RangedAudioParameterAttributes< Derived, Value >::withStringFromValueFunction | ( | StringFromValue | x | ) | const

An optional lambda function that converts a non-normalised value to a string with a maximum length.

This may be used by hosts to display the parameter's value.

References withMember(), and gl::x.

Referenced by AudioProcessorValueTreeStateParameterAttributes::withStringFromValueFunction().

## ◆ withValueFromStringFunction()

template<typename Derived , typename Value >

JUCE_NODISCARD auto RangedAudioParameterAttributes< Derived, Value >::withValueFromStringFunction | ( | ValueFromString | x | ) | const

An optional lambda function that parses a string and converts it into a non-normalised value.

Some hosts use this to allow users to type in parameter values.

References withMember(), and gl::x.

Referenced by AudioProcessorValueTreeStateParameterAttributes::withValueFromStringFunction().

## ◆ withLabel()

template<typename Derived , typename Value >

JUCE_NODISCARD auto RangedAudioParameterAttributes< Derived, Value >::withLabel | ( | String | x | ) | const

See AudioProcessorParameterWithIDAttributes::withLabel()

References AudioProcessorParameterWithIDAttributes::withLabel(), withMember(), and gl::x.

Referenced by AudioProcessorValueTreeStateParameterAttributes::withLabel().

## ◆ withCategory()

template<typename Derived , typename Value >

JUCE_NODISCARD auto RangedAudioParameterAttributes< Derived, Value >::withCategory | ( | Category | x | ) | const

See AudioProcessorParameterWithIDAttributes::withCategory()

References AudioProcessorParameterWithIDAttributes::withCategory(), withMember(), and gl::x.

Referenced by AudioProcessorValueTreeStateParameterAttributes::withCategory().

## ◆ withMeta()

template<typename Derived , typename Value >

JUCE_NODISCARD auto RangedAudioParameterAttributes< Derived, Value >::withMeta | ( | bool | x | ) | const

See AudioProcessorParameter::isMetaParameter()

References withMember(), AudioProcessorParameterWithIDAttributes::withMeta(), and gl::x.

Referenced by AudioProcessorValueTreeStateParameterAttributes::withMeta().

## ◆ withAutomatable()

template<typename Derived , typename Value >

JUCE_NODISCARD auto RangedAudioParameterAttributes< Derived, Value >::withAutomatable | ( | bool | x | ) | const

See AudioProcessorParameter::isAutomatable()

References AudioProcessorParameterWithIDAttributes::withAutomatable(), withMember(), and gl::x.

Referenced by AudioProcessorValueTreeStateParameterAttributes::withAutomatable().

## ◆ withInverted()

template<typename Derived , typename Value >

JUCE_NODISCARD auto RangedAudioParameterAttributes< Derived, Value >::withInverted | ( | bool | x | ) | const

See AudioProcessorParameter::isOrientationInverted()

References AudioProcessorParameterWithIDAttributes::withInverted(), withMember(), and gl::x.

Referenced by AudioProcessorValueTreeStateParameterAttributes::withInverted().

## ◆ getStringFromValueFunction()

template<typename Derived , typename Value >

JUCE_NODISCARD const auto & RangedAudioParameterAttributes< Derived, Value >::getStringFromValueFunction | ( |  | ) | const

An optional lambda function that converts a non-normalised value to a string with a maximum length.

This may be used by hosts to display the parameter's value.

## ◆ getValueFromStringFunction()

template<typename Derived , typename Value >

JUCE_NODISCARD const auto & RangedAudioParameterAttributes< Derived, Value >::getValueFromStringFunction | ( |  | ) | const

An optional lambda function that parses a string and converts it into a non-normalised value.

Some hosts use this to allow users to type in parameter values.

## ◆ getAudioProcessorParameterWithIDAttributes()

template<typename Derived , typename Value >

JUCE_NODISCARD const auto & RangedAudioParameterAttributes< Derived, Value >::getAudioProcessorParameterWithIDAttributes | ( |  | ) | const

Gets attributes that would also apply to an AudioProcessorParameterWithID.

The documentation for this class was generated from the following file:

- juce_RangedAudioParameter.h